#define _GNU_SOURCE
#include <stdio.h>
#include <jsrandom.h>
#include <tf_camera.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <image.h>
#include <tf_calib.h>
#include <r2x2.h>
#include <r2.h>
#include "lk.h"
#include "lk_error_M.h"
#include "track_parameters.h"
#include "at_process_frame.h"
#include "lk_error_STB.h"
#include "numeric.h"

int main (int argc, char *argv[])
{
   if (argc < 2) {
       fprintf(stderr, "error - usage: %s orig_image_coords.dat gauss_out_coords.dat\n", argv[0]);   
       exit(1);
   }

   targets_data_t tdat = (targets_data_t)malloc(sizeof(struct _targets_data_t));
   
   tf_read_image_positions (argv[1], &tdat->ntargets, &(tdat->p_i));

   int mark;
   for (mark = 0; mark < tdat->ntargets; mark++) {
       tdat->p_i[mark].c[0] += dgaussrand(); 
       tdat->p_i[mark].c[1] += dgaussrand(); 
   }  

   FILE *fout;

   fout = fopen (argv[2], "w");
   
   fprintf(fout, "%d\n", tdat->ntargets);
   for (mark = 0; mark < tdat->ntargets; mark++) {
        fprintf(fout, "%f %f\n", tdat->p_i[mark].c[0], tdat->p_i[mark].c[1]);
   }  
 
   fclose(fout);
 
   return 0;

}
