#include <malloc.h>
#include "numeric.h"

int main (int argc, char *argv[])
{
    auto double func (int nz, double *z);

    double func (int nz, double *z) {
         int j;
         double sum = 0.0;
         for (j = 0;  j < nz; j++) {
             sum += z[j]*z[j];  
         }
         sum += z[0]*z[1]; 
         return sum; 
    }   
    int nz = 4;
    
    double z_c[4] = {10, 20, 30, 40};
    double step[4] = {0.001, 0.001, 0.001, 0.001};

    double J_num[nz];  
    double H_num[nz*nz];  

    double Q = func(nz, z_c);

    numeric_diff (func, nz, z_c, step, J_num); 
    numeric_diff2 (func, nz, z_c, step, H_num); 
 
    int i, j;
    double tol = 1.0e-14;
    for (i = 0; i < nz; i++) {
      for (j = 0; j < nz; j++) {
         double H_alg;

         if (i == j) 
             H_alg = 2;
         else if ((i + j) == 1) {
             H_alg = 1; 
         } 
         else {
             H_alg = 0;
         }
         double H_diff = H_num[nz*i + j] - H_alg;
         if (fabs(H_diff) > tol*fabs(Q)) {
             fprintf(stderr, "H[%d,%d] = %+22.15e, H_num = %+22.15e, diff = %+22.15e\n", i, j, H_alg, H_num[nz*i + j], H_diff);
         }
      }
      double J_alg = 2*z_c[i];
      if (i == 0)
         J_alg += z_c[1];
      else if (i == 1)
         J_alg += z_c[0];

      double J_diff = J_num[i] - J_alg;
      if (fabs(J_diff) > tol*fabs(Q)) {
          fprintf(stderr, "J[%d] = %+22.15e, J_num = %+22.15e, diff = %+22.15e\n", i, J_alg, J_num[i], J_diff);
      }

   }
   
    return 0;
} 
