#include "track_parameters.h"
#include "lk.h"
#include "numeric.h"
#include "numeric_min_nwgrad.h"
#include "lk_error_M.h"
#include "lk_error_STB.h"
#include <stdio.h>

void track_parameters_print(FILE *f)
{
  fprintf(f, "RED_FACTOR = %d\n", RED_FACTOR);
  fprintf(f, "MINIMIZE_ITERS = %d\n", MINIMIZE_ITERS);
  fprintf(f, "MARK_BLUR = %4.2f\n", MARK_BLUR);
  fprintf(f, "MARK_SUBSAMPLING = %d\n", MARK_SUBSAMPLING);
}

lk_error_function_t *parse_error_function_arg(char *arg)
{
  if (strcmp(arg, "STB") == 0) { return &lk_error_STB; }
  if (strcmp(arg, "M") == 0) { return &lk_error_M; }
  fprintf(stderr, "** invalid error function \"%s\"\n", arg);
  assert(FALSE);
}

numeric_minimizer_t *parse_minimizer_arg(char *arg)
{
  if (strcmp(arg, "iter") == 0) { return &numeric_iterated_Newton; }
  if (strcmp(arg, "safe") == 0) { return &numeric_new_safe_Newton; }
  if (strcmp(arg, "ostb") == 0) { return &numeric_STB_safe_Newton; }
  if (strcmp(arg, "nwgr") == 0) { return &numeric_grad_Newton; }
  fprintf(stderr, "** invalid minimizer \"%s\"\n", arg);
  assert(FALSE);
}
