/* Common parameters for feature tracking programs. */

#include "lk.h"
#include "numeric.h"

#define RED_FACTOR 2
/* Linear image size reduction factor at each scale in pyramids. */

#define MINIMIZE_ITERS 30
/* Number of internal iterations in error minimizing procedures. */

#define MARK_BLUR 0.4 
/* Extra blurring parameter for synthetic feature images. */

#define MARK_SUBSAMPLING 1 
/* Magnification factor of feature image relative to target image. */

lk_error_function_t *parse_error_function_arg(char *arg);
/* Parses {arg} into the name of a discrepancy function. */

numeric_minimizer_t *parse_minimizer_arg(char *arg);
/* Parses {arg} into the name of a minimization algorithm. */

void track_parameters_print(FILE *f);
/* Prints the common tracking parameters to {stderr}. */
