#ifndef __cimage_H__
#define __cimage_H__

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <assert.h>
#include <math.h>
#include <stdarg.h>
#include "image.h"


#define PPM_RAW_MAGIC 6

/* --------------    image structures   --------------*/

typedef struct _cimage_t {
  int nx;    /* Image width */
  int ny;    /* Image height */
  int ch;    /* Number of channels in the image*/
  image_t *C; /* Image pixels matrix pointer to all the channels */
} *cimage_t;
/* Struct that defines an image composed by a intermined number of channels */
/* e.g C[0] -> PGM files */
/* e.g C[0] -> Y, C[1] -> Cb, C[2] -> Cr */
/* e.g C[0] -> R, C[1] -> G,  C[2] -> B */

/* --------   Basic image and auxiliary functions  --------*/
cimage_t cimage_alloc (int nx, int ny, int ch);
/* Returns a cimg structure (RGB) with {nx} columns and {ny} rows. */

void cimage_free (cimage_t cimg);
/* Disallocates the {cimg} structure */

void cimage_write_to_ppm (cimage_t cimg, int magic, int maxval, char *fname);

#endif
