#ifndef __image_pyramid_list_H__
#define __image_pyramid_list_H__

#define _GNU_SOURCE
#include <stdio.h>
#include "image.h"
#include "image_pyramid.h"


typedef struct _image_pyramid_list_t {
  int npyramids;      /* Number of pyramids inside in a list*/
  image_pyramid_t *pyrs; /* Pyramids data */
} *image_pyramid_list_t;
/* Struct that defines a list of pyramids of images */

image_pyramid_list_t image_pyramid_list_alloc (int npyramids);
/* Allocates a pyramid list {plist} with space for {npyramids} pyramids.
   Does not create any pyramids. Is necessary to use
   the functions image_pyramid_from_image or image_pyramid_alloc to allocate 
   each pyramid. e.g: plist->pyrs[i] = image_pyramid_from_image (...) */

void image_pyramid_list_free (image_pyramid_list_t plist);
/* Deallocates each pyramid in {plist}, then deallocates the {plist}
  itself.  */ 


#endif
