#ifndef __interpolate_H__
#define __interpolate_H__

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

/* LINEAR */

void interpol_linear 
    ( double t, 
      double v[], 
      double *s, 
      double *ds, 
      double *d2s );
/* Linear interpolation. */

void interpol_bilinear 
    ( double xfrac, 
      double yfrac, 
      double v00, 
      double w00, 
      double v10, 
      double w10, 
      double v01, 
      double w01, 
      double v11, 
      double w11, 
      double *s  );
/* Bilinear interpolation. */

/* QUADRATIC */

void interpol_spline_2_B 
    ( double t, 
      double v[], 
      double *s, 
      double *ds, 
      double *d2s );
/* Quadratic B-spline (C1-continuous) */

/* CUBIC */

void interpol_spline_3_A 
    ( double t, 
      double v[], 
      double *s, 
      double *ds, 
      double *d2s );
/* Cubic interpolant (not C2-continuous; is it C1-continuous?) */

void interpol_spline_3_B 
    ( double t, 
      double v[], 
      double *s, 
      double *ds, 
      double *d2s );
/* Cubic B-spline (C2-continuous cubic spline, non-interpolating) */

void interpol_spline_3_C 
    ( double t, 
      double v[], 
      double *s,  
      double *ds, 
      double *d2s );
/* High resolution cubic spline interpolant (C1 continuous), with a = -0.5 */

#endif

