#include "ipng.h"


cimage_t read_png (char *filename)
{
  png_structp png_ptr;
  png_infop info_ptr, end_info;
  png_bytep *row_pointers;
  
  FILE *fp;

  cimage_t cimg = NULL;  
   
  png_uint_32 nx, ny;
  int bit_depth,color_type,interlace_type,compression_type,filter_method;

  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, (png_voidp)NULL,NULL,NULL);
  if (!png_ptr)
      return cimg;
  
  info_ptr = png_create_info_struct(png_ptr);
  if (!info_ptr) {
      png_destroy_read_struct(&png_ptr,(png_infopp)NULL, (png_infopp)NULL);
      return cimg;
  }
  
  end_info = png_create_info_struct(png_ptr);
  if (!end_info) {
      png_destroy_read_struct(&png_ptr, &info_ptr,(png_infopp)NULL);
      return cimg;
  }  

  fp = fopen (filename, "rb");
  png_init_io(png_ptr, fp);

  png_read_png(png_ptr, info_ptr, PNG_TRANSFORM_STRIP_ALPHA | PNG_TRANSFORM_PACKING, NULL);

  png_get_IHDR(png_ptr, info_ptr, &nx, &ny, &bit_depth, &color_type, &interlace_type,&compression_type, &filter_method);

  if (color_type == PNG_COLOR_TYPE_PALETTE)
    png_set_palette_to_rgb(png_ptr);

  row_pointers = png_get_rows(png_ptr, info_ptr);

  cimg = cimage_alloc (nx, ny, png_get_channels(png_ptr, info_ptr));

  int iy, ix;
  for (iy = 0; iy < cimg->ny; iy++) {
      for (ix = 0; ix < cimg->nx; ix++) {
         int pngR = row_pointers[iy][(3*ix)+0];
         int pngG = row_pointers[iy][(3*ix)+1];
         int pngB = row_pointers[iy][(3*ix)+2];
         /*ver se nao esta trocado ([passando linha, coluna)*/
	 cimg->C[0]->val[iy][ix] = (double)pngR;
	 cimg->C[1]->val[iy][ix] = (double)pngG;
	 cimg->C[2]->val[iy][ix] = (double)pngB;
      }
  }    

  fclose(fp);
  png_destroy_read_struct(&png_ptr, &info_ptr,&end_info);
  
  return cimg; 
}



