#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <image.h>
#include <tf_calib.h>
#include <r2x2.h>
#include <r2.h>

int main (int argc, char *argv[])
{
  /*Verify memory*/
  void *trash = malloc(1);
  struct mallinfo info;
  int MemDinInicial, MemDinFinal;
  /*End*/

  free(trash);
  info = mallinfo();
  MemDinInicial = info.uordblks;

  image_t M = image_read_pgm (argv[1]);
  
  /* Tests of {image_extract_translated_mark} */
  //int Rnx = M->nx/3, Rny = M->ny/4;
  int Rnx = 4*8, Rny = 4*6;
  image_t R = image_alloc (Rnx, Rny); 
  int subsampling = 1;
  //double alpha = 0.8;
  //double beta = 0.1;
  double alpha = 0.549718753576458;
  double beta = 0.136743044540223;

  //alpha 0.549718753576458, beta 0.136743044540223, px 91.628208900397652, py 69.005933313243190 sub 1, nx 8, ny 6
  //r2_t p_i = (r2_t){{ 0.75*Rnx, 0.75*Rny }};
  //r2_t p_i = (r2_t){{91.56, 69.01}};
  r2_t p_i = (r2_t){{91.62820890039, 69.0059333132}};
  //r2_t p_i = (r2_t){{69.01, 91.56}};
  image_extract_translated_mark(M, R, subsampling, alpha, beta, p_i);
    
  char *R_name = NULL;
  asprintf(&R_name, "R_raw.pgm");
  image_write_pgm (R, PGM_RAW_MAGIC, MAXVAL, R_name);
  image_free (R);
  free(R_name);
  
  image_free (M);
  info = mallinfo();
  MemDinFinal = info.uordblks;
  if (MemDinInicial!=MemDinFinal)
    { fprintf(stderr, "** main: memory leak - %d blocks\n", MemDinFinal-MemDinInicial); }
  return 0;
} 
