#ifndef tf_calib_refine2_H
#define tf_calib_refine2_H

/* Non-linear calibration refinement step - version 2. */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <ctype.h>
#include <assert.h>
#include <values.h>
#include <f2c.h>
#include <lmdif.h>
#include <r3.h> 
#include <r2.h> 
#include <r4x4.h> 
#include <rmxn.h> 
#include <affirm.h>
#include "tf_camera.h"
#include "tf_calib.h"

void tf_calib_refine2_gather_optimization_params
  ( int nparams,
    doublereal params[],
    camera_specs_t cspec,
    calibration_data_t cdat,
    camera_parameters_t cpar,
    tf_optimization_choice_t *which );

void tf_calib_refine2_scatter_optimization_params
  ( int nparams,
    doublereal params[],
    camera_specs_t cspec,
    calibration_data_t cdat,
    camera_parameters_t cpar,
    tf_optimization_choice_t *which );

double tf_calib_refine2_calc_Tz
  ( double zc_star,
    calibration_data_t cdat,
    camera_parameters_t cpar );

double tf_calib_refine2_calc_zc_star 
  ( calibration_data_t cdat,
    camera_parameters_t cpar );

#endif
