#include <image.h>
#include <affirm.h>
#include "tf_camera.h"
#include "tf_camera_image.h"

image_t image_apply_pincushion (camera_parameters_t cpar, image_t img)
{
    int iy, ix;
    image_t pin;
    pin = image_alloc(img->nx, img->ny);

    for (iy = 0; iy < img->ny; iy++) {
        for (ix = 0; ix < img->nx; ix++) {

            r2_t pi;
            pi.c[0] = iy;
            pi.c[1] = ix;
            r2_t pd = tf_image_coords_to_sensor_coords (cpar, pi);
            r2_t pu = tf_distorted_sensor_coords_to_undistorted_sensor_coords (cpar, pd);
            r2_t npi = tf_sensor_coords_to_image_coords (cpar, pu);
 
            double v;
            image_eval_bilinear (npi.c[0], npi.c[1], img, &v);
            pin->val[iy][ix] = v; 
        }
    }
    return pin;
}
