#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <pswr.h>
#include <frgb.h>
#include <tf_camera.h>
#include <tf_errors.h>
#include <tf_targets.h>
#include <tf_calib.h>

void tf_plot_cameras
  ( PSStream *ps, 
    char *name, 
    int nmarks,
    r3_t p_w[], 
    int ncpars,
    camera_parameters_t cpar[],
    r2_t p_i[], 
    double hSize,
    double vSize,
    double hMrg,
    double vMrg,
    double Nx,
    double Ny,
    double mRadius,
    int mStyle ); 
  /* For each {ip} in {0..ncpars}, if {p_w} and {cpar[ip]} are not
    NULL, computes the positions {p_i} from {p_w} using each
    {cpar[ip]} and plots them with style {mstyle+ip}. Then, if {p_i}
    is not NULL, plots the marks {p_i} with style {mStyle + ncpars}.
    All marks are printed with size {mRadius}. */

void tf_plot_marks
  ( PSStream *ps, 
    int nmarks,
    r2_t p_i[], 
    double mRadius,
    int mStyle,
    frgb_t mColor );
/* Plots all marks {p_i[0..nmarks-1]} to the Postscript stream {ps},
  with style {mStyle}, size {mRadius}, and fill color {mColor}.  The
  styles are: 0 = squares, 1 = circles, 2..oo = crosses. */

void pswr_cross(PSStream *ps, double xc, double yc, double radius);
  /* Draws a cross at {(xc,yc)} with the given radius in mm.
   !!! Should be in {pswr.h}. !!! */

