#ifndef tf_math_H
#define tf_math_H

/* Miscellaneous math functions. */

#define SIGNBIT(a) (((a) > 0) ? 0 : 1)

/* Some math libraries may not have the sincos() routine */
#ifdef _SINCOS_
void sincos();
#define SINCOS(x,s,c)   sincos(x,&s,&c)
#else
double sin(), cos();
#define SINCOS(x,s,c)   s=sin(x);c=cos(x)
#endif

#define SQR(a) ((a) * (a))

#define SQRT3 1.732050807568877293527446341505872366943
#define SQRT(x) sqrt(fabs(x))
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#define CUB(a) ((a)*(a)*(a))


#endif
